;
;------------------*
; Textverarbeitung *
;      TEXV4       *
; SORED     EDIT   *
;alt 13.2.86       *
;15.9.86   H.Voelz *
;------------------*
;
        ORG     0C60AH
;
;Monitorroutinen
CHRINZ  EQU     0E839H
AUSGB   EQU     0E7E4H
CONVM   EQU     0E880H
VIDEO   EQU     0EB87H
CLS     EQU     0EB4BH
CRLF    EQU     0E830H
RECURS  EQU     0EB7FH
SAVCURS EQU     0EB63H
CURSOR  EQU     0EB6DH
TABLE   EQU     0F800H
CHAR254 EQU     0FFF0H
;
;Subroutinen
DATFEL  EQU     0C05EH
ZEIADR  EQU     0C069H
ADR1    EQU     0C079H
DHEX    EQU     0C0E5H
ABSTBC  EQU     0C10CH
;
;Speicherplaetze
HIMEM1  EQU     0F000H
ZG      EQU     HIMEM1+11
EN1     EQU     ZG+1
EN2     EQU     EN1+2
EN3     EQU     EN2+2
STADR   EQU     EN3+2
ENADR   EQU     STADR+2
STZE    EQU     ENADR+2
MAZE    EQU     STZE+2
;
;Text
DIT     EQU     0DB32H
;
;Sonderzeichen
EOF     EQU     0FFH
ZVB     EQU     188 ;
DCR     EQU     177   ;
;
;--------------------------------------------*
;Berechnet Anzahl zu verschiebender Zeichen  *
; -> DE = Cursor-, HL = Zeilenend-Adresse    *
;--------------------------------------------*
DELTA   CALL    RECURS
        LD      A,L
        AND     3FH
        SUB     40H
        CPL
        LD      C,A
        LD      B,0     ;BC=#CHAR
        EX      DE,HL   ;DE=Cursor
        PUSH    BC
        POP     HL
        ADD     HL,DE   ;Zeilenende
        OR      C       ;Test BC=0
        RET
;
;------------------------------*
; Negiert Zeichen unter Cursor *
;------------------------------*
INVERSE PUSH    IX
        CALL    CURSOR
        LD      (HL),0FEH
        LD      L,(IY+67H) ;CHAR unter Cursor
        LD      H,0
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        LD      DE,TABLE
        ADD     HL,DE   ;weist auf Zeichen
        LD      IX,CHAR254
        LD      B,8     ;Spaltenzahl
INV1    LD      A,(HL)
        CPL
        LD      (IX),A
        INC     HL
        INC     IX
        DJNZ    INV1-$
        POP     IX
        RET
;
;==============*
;  Editieren   *
;==============*
EDITOR  LD      HL,DIT
        CALL    AUSGB
EDIT    CALL    INVERSE
        CALL    CHRINZ
        CP      0BH
        JR      Z,TAB-$
        CP      7FH
        JR      Z,RUBOUT-$
        CP      0DH
        JR      Z,ENEDIT-$
        CP      0CH
        JP      Z,CLS
        CP      1BH
        JP      Z,CLS
        CP      5
        JR      Z,EXPAND-$
        CP      12H
        JR      Z,REDUCE-$
VID     CALL    VIDEO
        JR      EDIT-$
;
RUBOUT  LD      A,8
        JR      VID-$
;
TAB     LD      B,6
        LD      A,13H
TAB1    CALL    VIDEO
        DJNZ    TAB1-$
        JR      EDIT-$
;
EXPAND  CALL    DELTA
        JR      Z,INSPACE-$
        PUSH    HL
        POP     DE
        DEC     HL
        LDDR
        INC     HL
        JR      INSPACE-$
;
REDUCE  CALL    DELTA
        JR      Z,INSPACE-$
        PUSH    DE
        POP     HL
        INC     HL
        LDIR
        DEC     HL
INSPACE LD      A,20H   ;Space
        LD      (HL),A
        CALL    SAVCURS
        JR      EDIT-$
;
ENEDIT  LD      A,0DH
        CALL    VIDEO
        CALL    RECURS
        CALL    CONVM
        JP      NC,ERROR1
        LD      A,D
        AND     E
        INC     A
        JR      NZ,NFFFF-$
        LD      A,23    ;Cursor up
        CALL    VIDEO
        JR      ENEDIT-$
;DE=Zeilen-Nr. HL im Bidschirm danach
NFFFF   PUSH    HL
        EX      DE,HL
        CALL    DHEX
        EX      DE,HL
        LD      HL,(MAZE)
        DEC     HL
        OR      A
        SBC     HL,DE
        POP     HL
        JP      C,ERROR1
        PUSH    HL
        CALL    ZEIADR
        LD      (EN1),HL
        INC     DE
        CALL    ZEIADR
        LD      (EN2),HL
        POP     HL
;Video auslagern hinter ENADR
        LD      DE,(ENADR)
        INC     HL
SUCHW   PUSH    HL
        PUSH    HL
        LD      BC,58
        ADD     HL,BC
        LD      A,32
SUCHE   CP      (HL)
        DEC     BC
        DEC     HL
        JR      Z,SUCHE-$
        POP     HL
KRIT1   INC     BC
KRIT    INC     BC
        XOR     A
        CP      B
        JR      NZ,KRIT-$
        CP      C
        JR      Z,KRIT-$
        LDIR
        DEC     HL
        LD      A,(HL)
        CP      188
        POP     HL
        JR      NZ,SUCH2-$
        LD      BC,64
        ADD     HL,BC
        JR      SUCHW-$
SUCH2   XOR     A
        LD      (DE),A
;Einordnen
        LD      HL,(EN1)
        LD      DE,(ENADR)
UEBTR   XOR     A
        CP      (HL)
        LD      A,(DE)
        LD      (HL),A
        INC     HL
        INC     DE
        JR      Z,LUFTS-$
        OR      A
        JR      NZ,UEBTR-$
;zuviel Luft, vekuerzen
        PUSH    HL
        LD      HL,(ENADR)
        LD      DE,(EN2)
        CALL    ABSTBC
        POP     HL
        JR      Z,EDITEN-$
        JR      C,EDITEN-$
        EX      DE,HL
        LDIR
        LD      (ENADR),DE
EDITEN  CALL    CRLF
        JP      EDIT
;Luft schaffen ?
LUFTS   OR      A
        JR      Z,EDITEN-$
;ja
        LD      BC,0
        LD      HL,(ENADR)
UEBTR2  LD      A,(DE)
        LD      (HL),A
        INC     HL
        INC     DE
        INC     BC
        OR      A
        JR      NZ,UEBTR2-$
        LD      (ENADR),HL
        PUSH    HL
        ADD     HL,BC
        POP     DE
        EX      DE,HL
        PUSH    BC
        PUSH    HL
        LD      BC,(EN2)
        CALL    ADR1
        POP     HL
        INC     BC
        LDDR
        LD      HL,(ENADR)
        LD      DE,(EN2)
        POP     BC
        LDIR
        JR      EDITEN-$
;
ERROR1  CALL    DATFEL
        JR      EDITEN-$

